#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <memory.h>
#include <assert.h>

#define MAXPASS 5
#define SMAXPASS 5
#define DELTA 0.00001
#define SDELTA 0.0001
#define FTOL 0.00001

extern int ntaxa, nspecies;
extern int ngtrees;
extern double lik;

extern int *parents, **ppMatrix, *ppTwoRow[2], *ppTwoRowS[2], *ppTwoRow_temp[2],*ppTwoRowS_temp[2], ***pppTR, ***pppTRS, *filled_ind, *filled_indS, *CoalVec, *CoalVec2, *CoalVecL, *CoalVecR, *recalced, *SpecCount, **SpecVec, **ppSpecConUsed, counteri, burnin, extra_burnin, bound_total_iter, search;
extern double *TimeVec, *TimeVec_temp, *TimeVecS, *TimeVecS_temp, **ppTimeVec, **ppTimeVecS, *ChangeNodeLength, **ppLengthMat, **ppLengthMatS, **ppSpecCon, **ppLikMat, **ppTipMat, previous_lik, ci;
extern float beta, mu, theta;
extern int no_topo_stop, no_to_stop, no_topo_changes, no_accept, no_last_un, bound_last_un, cbound, done_burnin, verbose;
extern int bound_un, cbound_un;

typedef char naym[15];

struct Node {
  char *iTree;
  int first_hit;
  int first_anneal;
  double max_lik;
  int times_hit;
  int loc_ppTR;
  struct Node *Next;
};

typedef struct Node *Link;

extern Link Head, currenttree;
extern int NodeCount, NodeCount2, use_last, last_delete;
extern int first_annealing_pass, num_saved_trees;
extern naym *taxname, *speciesname;

/* in main.c */
long int random_seed();

/* in tree.c */
int FindParentI(int target);
int NextNode(int next);
double ReadLength(FILE *fp);
int AddToNode(int current,int next,int last_tip,FILE *fp,double read_length);
int FindLastOpen(int current);
int CloseBack(int open, int current, int last_char, int last_tipp, FILE *fp, double read_length);
double ReadTree(FILE *fp);
double FindTotalTime();
void CalcTimeVec(double total, double rate);

/* in stree.c */
int FindParentIS(int target);
int NextNodeS(int next);
double ReadLengths(FILE *fp);
int AddToNodeS(int current,int next,int last_tip,FILE *fp,double read_length);
int FindLastOpenS(int current);
int CloseBackS(int open, int current, int last_char, int last_tipp, FILE *fp, double read_length);
double ReadTreeS(FILE *fp);

/* in lik.c */
void double_qsort(double *arr, unsigned n);
int FindParent(int target);
int FindParentTree(int target, int tree);
int AvailCoal(int branch);
double FindMRCA(int tax1, int tax2, int tree_num);
void GetSpecCon();
double GetBranchLik(double *CoalTimes, int ncoal, int navail, int node);
void GetMLLengths();
void CalcLik(int ntree);
double GetLik();

/* in branch.c */
void mnbrak(int target, double *ax, double *bx, double *cx, double *fa, double *fb, double *fc, double (*func)(int,double));
double brent(int target, double ax, double bx, double cx, double (*f)(int,double), double tol, double *xmin);
int AvailCoal2(int branch);
double LikAfterBranch(int tar, double new_time);
double GetMaxTime(int node);
double GetLength(int tar);
double OptNode(int tar);
double OptTree(int one_pass);

/* in compare.c */
void write_species_tree(int node, int previous_node);
void write_tree_root_saved(int node, int previous_node, Link pnode, FILE *res);
void write_tree_root_saved_nolens(int node, int previous_node, Link pnode, FILE *res);
void write_tree_root_place(int node, int previous_node, int place, FILE *res);
void FreeNode(Link n);
int DeleteMin();
Link AddNodeAscend(Link to_add, double new_lik, FILE *res);
void CreateList(void);
void PrintTiedTrees(FILE *res);
void FindBest();
int find_parent_temp(int target);
int find_gen(int current_node);
void make_indmat();
char *make_matnum(int **ppMatrix1);

/* in trbldg.c */
void FindMin(int *n1, int *n2, double *min_time);
void build_ML_tree();
void trbldg(FILE *res);

/* in anneal.c */
void anneal(FILE *results, long int seeda, long int seedb);
